-- timeControlledslidingGate3
-- @author: Daniel (Desperados93) W.
-- @date: 01.03.2011

-- Copyright () by Daniel "Desperados93" W.
   
  timeControlledslidingGate3 = {};
  
  local timeControlledslidingGate3_mt = Class(timeControlledslidingGate3);
  
  function timeControlledslidingGate3.onCreate(id)
      g_currentMission:addUpdateable(timeControlledslidingGate3:new(id));

  end;
  
  function timeControlledslidingGate3:new(id, customMt)
  
      local instance = {};
      if customMt ~= nil then
          setmetatable(instance, customMt);
      else
          setmetatable(instance, timeControlledslidingGate3_mt);
      end;
  
      instance.triggerId = id;
      addTrigger(id, "triggerCallback", instance);
  
      instance.gate = {};
      
      local num = getNumOfChildren(id);
      for i=0, num-1 do
          local childLevel1 = getChildAt(id, i);
          if childLevel1 ~= 0 and getNumOfChildren(id) >= 1 then
              local gate2Id = getChildAt(childLevel1, 0);
              if gate2Id ~= 0 then
                  table.insert(instance.gate, gate2Id);
              end;
          end;
      end;
  
      instance.isEnabled = true;
  
      self.count = 0;
  
      self.trans = 0;
      self.maxTrans = 9;
      self.minTrans = 0;
  	  
      return instance;
  end;
  
  function timeControlledslidingGate3:delete()
 
      removeTrigger(self.triggerId);
  end;
  	
  
function timeControlledslidingGate3:update(dt)
 
    
	local available = false;
	
	if  (g_currentMission.environment.dayTime > 18000000 and g_currentMission.environment.dayTime < 19800000) or --5 - 5.30 Uhr
		(g_currentMission.environment.dayTime > 22500000 and g_currentMission.environment.dayTime < 29412000) or --6.15 - 8.10 Uhr
		    (g_currentMission.environment.dayTime > 40824000 and g_currentMission.environment.dayTime < 45612000) or --11.2 - 12.4 Uhr
		       (g_currentMission.environment.dayTime > 55800000 and g_currentMission.environment.dayTime < 58212000) or --15.30 - 16.10 Uhr
                           (g_currentMission.environment.dayTime > 64188000 and g_currentMission.environment.dayTime < 72612000) then --17.50 - 20.10 Uhr

		available = true;
	end;
	
	if available == true then 
		local old = self.trans;
		if self.count > 0 then
			if self.trans < self.maxTrans then
				self.trans = self.trans + dt*0.008;    
			end;
		else  
			if self.trans > self.minTrans then
				self.trans = self.trans - dt*0.003;    
			end;
		end;
      
		for i=1, table.getn(self.gate) do
			setTranslation(self.gate[i], self.trans, 0, 0);
		end;
	end;
      
end;
    
  function timeControlledslidingGate3:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay)
  
      if onEnter and self.isEnabled then

          self.count = self.count + 1;
      elseif onLeave then
         self.count = self.count - 1;
      end; 
  end;
    
g_onCreateUtil.addOnCreateFunction("timeControlledslidingGate3OnCreate", timeControlledslidingGate3.onCreate);